<?php

// TODO: Switch to OAuth authentication.
// http://docs.nucleuscms.org/blog/13
class NP_AutoTwitter extends NucleusPlugin{
	private $itemIsDraft=-1;
	
	// name of plugin
	function getName(){
		return 'The Shtick Auto-Twitter for Nucleus';
	}

	// author of plugin
	function getAuthor(){
		return 'Sean Cox';
	}

	// an URL to the plugin website
	// can also be of the form mailto:foo@bar.com
	function getURL(){
		return 'http://www.theshtick.org/';
	}

	// version of the plugin
	function getVersion(){
		return '0.2';
	}

	// a description to be shown on the installed plugins listing
	function getDescription(){
		return 'Allows blog posts to be automatically announced via Twitter.';
	}

	function getEventList() { return array('PostAddItem','PreUpdateItem','PostUpdateItem','PostAddComment'); }
	
	function init() {
 		if (($this->getOption(UpdatePlugin)=="yes") || ($this->getOption(UpdatePlugin)=="")) {
 			$this->install(); # run the install function.
			$this->setOption('UpdatePlugin','no'); # !! leave this line, so Update option is a toggle function
 		}	
	} # end of init
	
	function event_PostAddComment(&$data) {
		global $manager,$blog;
		if($data['comment']['memberid'] > 0){
			if($this->getMemberOption($data['comment']['memberid'],'twitterComments')){
				// The following line is causing failure, as blogid is not present in the array.
				if($data['comment']['blogid']){
					$blogid=$data['comment']['blogid'];
				}
				else{
					$query = 'SELECT iblog FROM ' . sql_table('item') . ' WHERE inumber=' . intval($data['comment']['itemid']);
					$res = sql_query($query);
					$obj = mysql_fetch_object($res);
					$blogid = $obj->iblog;
				}

				if ($blogid) {
					$b =& $manager->getBlog($blogid);
				} else if ($blog) {
					$b =& $blog;
				} else {
					$b =& $manager->getBlog($CONF['DefaultBlog']);
				}
				$BlogURL = $b->getURL();
				$URLComponents=explode('?',createItemLink($data['comment']['itemid']));
				$LinkURL=$BlogURL.'?'.$URLComponents[1].'#c';
				
				$query =  'SELECT i.idraft as draft, i.inumber as itemid, i.iclosed as closed, '
				       . ' i.ititle as title, i.ibody as body, m.mname as author, '
				       . ' i.iauthor as authorid, i.itime, i.imore as more, i.ikarmapos as karmapos, '
				       . ' i.ikarmaneg as karmaneg, i.icat as catid, i.iblog as blogid '
				       . ' FROM '.sql_table('item').' as i INNER JOIN (' . sql_table('blog') . ' as b, '.sql_table('member').' as m) ON (b.bnumber=i.iblog AND i.iauthor=m.mnumber)'
				       . ' WHERE i.inumber=' . $data['comment']['itemid'];
		
				$items = sql_query($query);
				$item = mysql_fetch_object($items);

				$tweet=$this->getReplacedText($this->getMemberOption($data['comment']['memberid'],'twitterCommentsTempl'),$LinkURL,$item->title,$b->getName());

				$this->sendRawTweet($tweet,$this->getMemberOption($data['comment']['memberid'],'twitterUsername'),$this->getMemberOption($data['comment']['memberid'],'twitterPassword'));
			}
		}
	}
	
	function event_PostAddItem(&$data) {
		$query =  'SELECT i.idraft as draft, i.inumber as itemid,'
		       . ' i.ititle as title,'
		       . ' i.iauthor as authorid,'
		       . ' i.iblog as blogid '
		       . ' FROM '.sql_table('item').' as i'
		       . ' WHERE i.inumber=' . $data['itemid'];
				
		$items = sql_query($query);
		$item = mysql_fetch_object($items);
		if($this->getBlogOption($item->blogid,'twitterNewItems')){
			if($item->draft==0){
				$this->sendItemTweet($item);
			}
		}
	}
	
	function event_PreUpdateItem(&$data) {
		$query =  'SELECT i.idraft as draft'
		       . ' FROM '.sql_table('item').' as i'
		       . ' WHERE i.inumber=' . $data['itemid'];

		$items = sql_query($query);
		$item = mysql_fetch_object($items);
		$this->itemIsDraft=$item->draft;
	}
	
	function event_PostUpdateItem(&$data) {
		$query =  'SELECT i.idraft as draft, i.inumber as itemid,'
		       . ' i.ititle as title,'
		       . ' i.iauthor as authorid,'
		       . ' i.iblog as blogid '
		       . ' FROM '.sql_table('item').' as i'
		       . ' WHERE i.inumber=' . $data['itemid'];

		$items = sql_query($query);
		$item = mysql_fetch_object($items);
		if($this->getBlogOption($item->blogid,'twitterNewItems')){
			if(($this->itemIsDraft==1)&&($item->draft==0)){
				$this->sendItemTweet($item);
			}
		}
	}
	
	function install(){
		$this->updateOption('UpdatePlugin',"Update the plugin options on next call of this plugin. This option will reset it self when updated. !!When this option is set to 'yes' all new and redefined options within this version will be reset to default values!!.","yesno","no");
		if (count($this->getAllMemberOptions('twitterUsername'))==0)
			$this->createMemberOption('twitterUsername','Twitter Username','text');
		if (count($this->getAllMemberOptions('twitterPassword'))==0)
			$this->createMemberOption('twitterPassword','Twitter Password','password');
		if (count($this->getAllMemberOptions('twitterComments'))==0)
			$this->createMemberOption('twitterComments','Tweet Comments','yesno');
		if (count($this->getAllMemberOptions('twitterCommentsTempl'))==0)
			$this->createMemberOption('twitterCommentsTempl','Tweet Template','text','Commented on %##BLOGNAME##% - %##URL##%');
		if (count($this->getAllBlogOptions('twitterNewItems'))==0)
			$this->createBlogOption('twitterNewItems','Tweet New Posts','yesno');
		if (count($this->getAllBlogOptions('twitterNewItemsTempl'))==0)
			$this->createBlogOption('twitterNewItemsTempl','Tweet Template','text','Posted new blog entry: %##TITLE##% - %##URL##%');
	}

	function unInstall(){
		$this->deleteMemberOption('twitterUsername');
		$this->deleteMemberOption('twitterPassword');
		$this->deleteMemberOption('twitterComments');
		$this->deleteMemberOption('twitterCommentsTempl');
		$this->deleteBlogOption('twitterNewItems');
		$this->deleteBlogOption('twitterNewItemsTempl');
	}

	function updateOption($option,$description,$type,$default) {
		//Update an option.
		//Basicly it saves the value of the option to update, then deletes the options and then creates the option with the saved value. The option will then be at the bottem of the option list in the 'edit option' page of the plugin.
	    if ($this->getOption($option)=="") {
			$default_val=$default;
			ACTIONLOG::ADD(INFO,'{NP_PHPList} option :'.$option.' created.');
		 } else {
			$default_val=$this->getOption($option);
			ACTIONLOG::ADD(INFO,'{NP_PHPList} option :'.$option.' updated.');
			$this->deleteOption($option);
		}
		$this->createOption($option,$description,$type,$default_val);
	}	#end of updateOption

	function supportsFeature ($what){
		switch ($what)
		{
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	/**
	 * Used to take a string and make certain text substitutions as follows:
	 * %##BLOGNAME##% - The name of the blog.
	 * %##TITLE##% - The title of the relevant item.
	 * %##URL##% - The url of the relevant item.
	 * 
	 * @param $text The text to parse and make replacements in.
	 * @param $url The url of the relevant item.
	 * @param $title The title of the relevant item.
	 * @param $blogname The name of the relevant blog.
	 * @return A string consisting of $text with various replacements.
	 */
	function getReplacedText($text,$url,$title,$blogname){
		$rtext=$text;
		$rtext = str_replace('%##BLOGNAME##%', $blogname, $rtext);
		$rtext = str_replace('%##TITLE##%', $title, $rtext);
		$rtext = str_replace('%##URL##%', $url, $rtext);
		return $rtext;
	}
	
	/**
	 * 
	 * @param $item Needs to be an object with properties blogid, authorid, itemid, and title.
	 * @return unknown_type
	 */
	function sendItemTweet(&$item){
		global $manager,$blog;
		// Post tweet for item, but only if the user has a username and password specified.
		if($this->getMemberOption($item->authorid,'twitterUsername')&&$this->getMemberOption($item->authorid,'twitterPassword')){
			$b =& $manager->getBlog($item->blogid);
			$BlogURL = $b->getURL();
			$URLComponents=explode('?',createItemLink($item->itemid));
			$LinkURL=$BlogURL.'?'.$URLComponents[1];
			$tweet=$this->getReplacedText($this->getBlogOption($item->authorid,'twitterNewItemsTempl'),$LinkURL,$item->title,$b->getName());
			$this->sendRawTweet($tweet,$this->getMemberOption($item->authorid,'twitterUsername'),$this->getMemberOption($item->authorid,'twitterPassword'));
		}
	}
	
	function sendRawTweet($msg,$username,$password){
		$url = 'http://twitter.com/statuses/update.xml';
		$curl_handle = curl_init();
		curl_setopt($curl_handle, CURLOPT_URL, $url);
		curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 2);
		curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl_handle, CURLOPT_POST, 1);
		curl_setopt($curl_handle, CURLOPT_POSTFIELDS, "status=".urlencode(utf8_encode($msg)));
		curl_setopt($curl_handle, CURLOPT_USERPWD, "$username:$password");
		$buffer = curl_exec($curl_handle);
		curl_close($curl_handle);
	}

}
?>